Subject: bug#56558: closed (Re: [PATCH] build: Simpler percentage calculation.)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 16 Jul 2022 22:08:02 +0000

Your bug report

#56558: [PATCH] build: Simpler percentage calculation.

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
56558: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=56558
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [PATCH] build: Simpler percentage calculation.
From: Csepp <[email-masked]>
To: Liliana Marie Prikler <[email-masked]>
Cc: Csepp <[email-masked]>, [email-masked]
Date: Sun, 17 Jul 2022 00:04:34 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Liliana Marie Prikler <[email-masked]> writes:

> Am Freitag, dem 15.07.2022 um 12:17 +0200 schrieb Csepp:
>> 
>> Liliana Marie Prikler <[email-masked]> writes:
>> 
>> > Am Donnerstag, dem 14.07.2022 um 16:58 +0200 schrieb raingloom:
>> > > * build-aux/compile-all (%): Simpler calculation that avoids
>> > > intermediate float.
>> > > ---
>> > >  build-aux/compile-all.scm | 2 +-
>> > >  1 file changed, 1 insertion(+), 1 deletion(-)
>> > > 
>> > > diff --git a/build-aux/compile-all.scm b/build-aux/compile-
>> > > all.scm
>> > > index 9ffbce43ad..6fdbe0dea8 100644
>> > > --- a/build-aux/compile-all.scm
>> > > +++ b/build-aux/compile-all.scm
>> > > @@ -89,7 +89,7 @@ (define (parallel-job-count*)
>> > >  
>> > >  (define (% completed total)
>> > >    "Return the completion percentage of COMPLETED over TOTAL as
>> > > an
>> > > integer."
>> > > -  (inexact->exact (round (* 100. (/ completed total)))))
>> > > +  (quotient (* 100 completed) total))
>> > I am fairly certain that this changes the semantics of %.  Try for
>> > example (% 23 24).
>> > 
>> > Cheers
>> 
>> It rounds down instead of up, which, :shrug:.
>> If that's a deal breaker, feel free to close this.
> It's not simply "rounding up", you need to round towards the nearest,
> which can be done with just quotient and remainder, but is probably
> more complicated than the float solution.

Yeah, I meant it rounds up in that case. Since it's only used for
indicating progress to the user, being off by 1% is not something I'd
worry about, but whatevs, I guess we can leave it as is.

Subject: [PATCH] build: Simpler percentage calculation.
From: raingloom <[email-masked]>
To: [email-masked]
Cc: raingloom <[email-masked]>
Date: Thu, 14 Jul 2022 16:58:51 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

* build-aux/compile-all (%): Simpler calculation that avoids intermediate float.
---
 build-aux/compile-all.scm | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/build-aux/compile-all.scm b/build-aux/compile-all.scm
index 9ffbce43ad..6fdbe0dea8 100644
--- a/build-aux/compile-all.scm
+++ b/build-aux/compile-all.scm
@@ -89,7 +89,7 @@ (define (parallel-job-count*)
 
 (define (% completed total)
   "Return the completion percentage of COMPLETED over TOTAL as an integer."
-  (inexact->exact (round (* 100. (/ completed total)))))
+  (quotient (* 100 completed) total))
 
 ;; Install a SIGINT handler to give unwind handlers in 'compile-file' an
 ;; opportunity to run upon SIGINT and to remove temporary output files.
-- 
2.37.0